Name: openssh
Version: 6.9p1
Release: 1
License: BSD
Summary: Open Source Secure Shell
Url: https://www.openssh.com/portable.html

# Requires PASE libiconv for ccsidtocs
BuildConflicts: libiconv-devel
BuildRequires: iconv-pase
BuildRequires: openssl-devel < 1.1.0
BuildRequires: zlib-devel

Source0: ftp://mirror.esc7.net/pub/OpenBSD/OpenSSH/portable/openssh-%{version}.tar.gz

Patch0: auth1.c.patch
Patch1: auth.c.patch
Patch2: configure.ac.patch
Patch3: configure.patch
Patch4: loginrec.c.patch
Patch6: openbsd-compat-bsd-setres_id.c.patch
Patch7: regress-ibmi.sh.patch
Patch8: openbsd-compat-Makefile.in.patch
Patch9: openbsd-compat-openbsd-compat.h.patch
Patch10: openbsd-compat-port-pase.c.patch
Patch11: openbsd-compat-port-pase.h.patch
Patch12: openbsd-compat-readpassphrase.c.patch
Patch13: platform.c.patch
Patch14: regress-cfgparse.sh.patch
Patch15: regress-agent-ptrace.sh.patch
Patch16: regress-test-exec.sh.patch
Patch17: servconf.c.patch
Patch18: servconf.h.patch
Patch19: session.c.patch
Patch20: sshd.c.patch
Patch21: uidswap.c.patch
Patch22: UPSTREAM_regress-keygen-knownhosts.sh.patch
Patch23: CVE-2015-5600.patch
Patch24: CVE-2015-6563.patch
Patch25: CVE-2015-6564.patch
Patch26: CVE-2015-6565.patch
Patch27: CVE-2016-0777.patch
Patch28: CVE-2016-1907.patch
Patch29: CVE-2016-1908.patch
Patch30: CVE-2016-3115.patch
Patch31: ssh-copy-id.patch
Patch32: CVE-2016-8858.patch
Patch33: UPSTREAM_7.3_compat.c.patch
Patch34: UPSTREAM_7.3_kex.c.patch
Patch35: UPSTREAM_7.4_allowuser.patch
Patch36: CVE-2016-10009.patch
Patch37: CVE-2016-10010.patch
Patch38: CVE-2016-10011.patch
Patch39: CVE-2016-10012.patch
Patch40: Makefile.in.patch

%description
OpenSSH is the premier connectivity tool for remote login with the SSH protocol. It encrypts all traffic to eliminate eavesdropping, connection hijacking, and other attacks. In addition, OpenSSH provides a large suite of secure tunneling capabilities, several authentication methods, and sophisticated configuration options.

The OpenSSH suite consists of the following tools:

    Remote operations are done using ssh, scp, and sftp.
    Key management with ssh-add, ssh-keysign, ssh-keyscan, and ssh-keygen.
    The service side consists of sshd, sftp-server, and ssh-agent. 

OpenSSH is developed by a few developers of the OpenBSD Project and made available under a BSD-style license. 

%prep
%setup -q

%patch40 -p1
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1
%patch26 -p1
%patch27 -p1
%patch28 -p1
%patch29 -p1
%patch30 -p1
%patch31 -p1
%patch32 -p1
%patch33 -p1
%patch34 -p1
%patch35 -p1
%patch36 -p1
%patch37 -p1
%patch38 -p1
# FIXME: this patch needs to be updated
%define _default_patch_fuzz 120
%patch39 -p1

%build

%configure \
  blibpath=%{_libdir}:/QOpenSys/usr/lib \
  --with-cflags="-maix64 -std=c99" \
  --with-cppflags="-I%{_includedir}" \
  --with-ldflags="-maix64 -Wl,-brtl -L%{_libdir}" \
  --sysconfdir=%{_sysconfdir}/ssh \
  --with-pid-dir=/tmp \
  --with-ssl-dir=/QOpenSys/etc/ssl \
  --with-sandbox=rlimit \
  --with-privsep-user=qsshd \
  --with-privsep-path=/QOpenSys/var/empty \
  --with-default-path=/QOpenSys/usr/bin:/usr/ccs/bin:/QOpenSys/usr/bin/X11:/usr/sbin:/usr/bin:%{_bindir} \
  --without-ssh1 \
  --without-pam \
  --without-rpath \
  --disable-utmp \
  --disable-utmpx \
  --disable-wtmp \
  --disable-wtmpx \
  --disable-libutil \
  # end

function undefine
{
  perl -p -i -e "s|#define $1 1|/* #undef $1 */|g" config.h
}

# TODO: Need to modify autoconf script and run autoreconf above
# # configure detects getpeereid, but the syscall is not implemented
# # no way to disable it in the autoconf script yet, so just hack
# # up the config.h configure has run
undefine HAVE_GETPEEREID
undefine HAVE_CLOCK_GETTIME

# Hack to fix link error
# ld: 0711-318 ERROR: Undefined symbols were found.
#         The following symbols are in error:
#  Symbol                    Inpndx  TY CL Source-File(Object-File) OR Import-File{Shared-object}
#                               RLD: Address  Section  Rld-type Referencing Symbol
#  ----------------------------------------------------------------------------------------------
#  .EVP_aes_128_cbc          [486]   ER PR sshkey.c(./libssh.a[sshkey.o])
#                                    00008e1c .text    R_RBR    [3548]  .sshkey_private_to_fileblob
# ER: The return code is 8.
# ld: 0711-317 ERROR: Undefined symbol: .EVP_aes_128_cbc
# collect2: error: ld returned 8 exit status
# The problem is that the linker behaves differently when linking in a "static library" when using
# run-time linking. When runtime linking is enabled, it will not resolve those symbols properly for
# whatever reason. So we hack around the problem by linking sshkey.o (the offending .o in the .a)
# specifically for any binaries that need it (found via trial and error).



%make_build all

%install

%make_install

install -c -m 0755 contrib/ssh-copy-id   %{buildroot}%{_bindir}
install -c -m  644 contrib/ssh-copy-id.1 %{buildroot}%{_mandir}/cat1

%files
%defattr(-, qsys, *none)

%{_bindir}/ssh
%{_bindir}/scp
%{_bindir}/ssh-add
%{_bindir}/ssh-agent
%{_bindir}/ssh-keygen
%{_bindir}/ssh-keyscan
%{_bindir}/sftp
%{_bindir}/slogin
%{_bindir}/ssh-copy-id

%{_sbindir}/sshd

%{_mandir}/cat1/ssh.1
%{_mandir}/cat1/scp.1
%{_mandir}/cat1/ssh-add.1
%{_mandir}/cat1/ssh-agent.1
%{_mandir}/cat1/ssh-keygen.1
%{_mandir}/cat1/ssh-keyscan.1
%{_mandir}/cat1/sftp.1
%{_mandir}/cat1/slogin.1

%{_mandir}/cat5/moduli.5
%{_mandir}/cat5/sshd_config.5
%{_mandir}/cat5/ssh_config.5

%{_mandir}/cat8/sshd.8
%{_mandir}/cat8/sftp-server.8
%{_mandir}/cat8/ssh-keysign.8
%{_mandir}/cat8/ssh-pkcs11-helper.8

%{_libexecdir}/ssh-keysign
%{_libexecdir}/ssh-pkcs11-helper
%{_libexecdir}/sftp-server

/QOpenSys/var/empty

%{_sysconfdir}/ssh/ssh_config
%{_sysconfdir}/ssh/moduli
%{_sysconfdir}/ssh/sshd_config

%changelog
